<?php

/**
 * inf_nota_credito actions.
 *
 * @package    cartera
 * @subpackage inf_nota_credito
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_nota_credito_consolActions extends sfQuery {

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para listar el informe nota debito
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            /* if (isset($request['estado'])) {
              if ($request['estado'] == 'false') {
              $estado = 0;
              } else {
              $estado = 1;
              }
              } else {
              $estado = 1;
              } */

            /*
             * Variables opcionales
             */
            //tercero
            // if (isset($request['id_mae_ter'])) {
            //   $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            // } else {
            //   $whereTercero = ' ';
            //}
            //tipo debito


            if (isset($request['id_con_credito'])) {
                $whereConCredito = " AND tab0.id_con_credito = " . $request['id_con_credito'];
            } else {
                $whereConCredito = ' ';
            }



            if (isset($request['id_mae_ter'])) {
                $whereTercero = " AND tab1.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }

            //tipo novedad - 20160928
            if (isset($request['id_tipo_novedad'])) {
                $whereTipoNovedad = "and tab0.id_tipo_novedad = " . $request['id_tipo_novedad'];
            } else {
                $whereTipoNovedad = ' ';
            }
            
            //Agregado filtro Punto de venta 20170214
            if(!empty($request['id_punto_venta'])){
                $wherePuntoVenta="and tab0.id_punto_venta = " . $request['id_punto_venta'];
            }else{    
                $wherePuntoVenta=' ';
            }

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
              To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
              and Tab0.estado = $estado
              $whereTercero
             */
            $sql = <<<EOD

select count(*) as count from (

select * from (


    select distinct 1 as orden,
    null as punto,   
    null as id_credito, 
    null as id_punto_venta, 
    null as id_tipo_credito, 
    null as sec_credito, 
    tab0.id_con_credito, 
    null as fecha_proceso_cre,
    null as num_doc, 
    null as estado, 
    null as valor_bruto_credet, 
    null as valor_retenciones, 
    null as valor_abono, 
    null as fecha_anu_cre, 
    null as motivo_anu, 
    null as concepto, 
    null as sec_debito, 
    null as id_tipo_debito, 
    null as fecha_debito, 
    null as desc_deb,
    null as descripcion_tipcre, 
    null as nitocc, 
    null as razon_soc, -1 as id_mae_ter,
    'NOTA CREDITO: ' || tab0.desc_corta_concre as tercero,
    null as id_tipo_novedad,
    null as descripcion_tipnov,
    null as desc_corta_tipnov 
    
    from(
    
        select tab0.*,
        tab13.id_tipo_novedad,
        tab13.descripcion AS descripcion_tipnov,
        tab13.desc_corta AS desc_corta_tipnov  
        
        from ca_credito_vencimientos tab0 
        join ca_debito tab1 on tab1.id_debito = tab0.id_debito 
        join ca_tipo_debito tab2 on tab2.id_tipo_debito = tab1.id_tipo_debito 
        join interceros ter on ter.id_mae_ter = tab1.id_mae_ter
        --left join intercer_du tab3 on tab3.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du_dir tab4 on tab4.id_mt_ubi = tab3.id_mt_ubi 
        left join interceros_du_dir_v tab4 on tab4.id_mae_ter = tab1.id_mae_ter  
        left join usuario tab5 on tab5.username = tab0.usuariolog 
        left join (
        select
        deta.*,
        row_number() over (
        partition by deta.id_debito
        order by deta.id_debito_detalle desc
        ) as rn
        from ca_debito_detalle deta
        )tab5 on tab5.id_debito = tab1.id_debito and tab5.rn=1
        join ca_producto tab6 on tab6.id_producto = tab5.id_producto 
        
        left join( 
        
        select id_credito,sum(nvl(valor,0)) as valor 
        from ca_excedentes 
        group by id_credito 
        )tab7 on tab7.id_credito = tab0.id_credito
        
        left join (
          select
           tab0.id_debito,
           tab0.id_vencimiento,
            to_char(wm_concat(distinct tab0.id_tipo_novedad)) as id_tipo_novedad,
            to_char(wm_concat(distinct tip.descripcion)) as descripcion,
            to_char(wm_concat(distinct tip.desc_corta)) as desc_corta
           from ca_novedad_cartera tab0
           left join ca_tipo_novedad tip
           on tip.id_tipo_novedad = tab0.id_tipo_novedad
           where
           tab0.anulado = 0
           $whereTipoNovedad
           group by
           tab0.id_debito,
           tab0.id_vencimiento   
        )tab13 
        on tab13.id_debito = tab1.id_debito 
        and tab13.id_vencimiento = tab0.id_vencimiento 
        
        where 
        tab0.fecha_proceso_cre between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD')
        $whereConCredito
        $whereTercero            
    
    
    )tab0
    
    where
    1 = 1
    $whereTipoNovedad 
    $wherePuntoVenta
    
    union 
    
    select 
    distinct 3 as orden, 
    null as punto,   
    null as id_credito, 
    null as id_punto_venta, 
    null as id_tipo_credito, 
    null as sec_credito, 
    id_con_credito, 
    null as fecha_proceso_cre, 
    null as num_doc,
    null as estado, 
    null as valor_bruto_credet, 
    null as valor_retenciones, 
    sum(nvl(valor_abono,0))+sum(nvl(diferencia_cambio,0))+sum(nvl(excedente,0)) as valor_abono, 
    null as fecha_anu_cre, 
    null as motivo_anu, 
    null as concepto, 
    null as sec_debito, 
    null as id_tipo_debito, 
    null as fecha_debito, 
    null as desc_deb, 
    null as descripcion_tipcre, 
    null as nitocc, 
    null as razon_soc
    , -1 as id_mae_ter,
    'TOTAL NOTA CREDITO: ' || desc_corta_concre as tercero,
    null as id_tipo_novedad,
    null as descripcion_tipnov,
    null as desc_corta_tipnov 
    
    from( 
    
        select tab0.*,tab7.valor as excedente,
        tab13.id_tipo_novedad,
        tab13.descripcion AS descripcion_tipnov,
        tab13.desc_corta AS desc_corta_tipnov
        
        from ca_credito_vencimientos tab0 
        join ca_debito tab1 on tab1.id_debito = tab0.id_debito 
        join ca_tipo_debito tab2 on tab2.id_tipo_debito = tab1.id_tipo_debito 
        join interceros ter on ter.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du tab3 on tab3.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du_dir tab4 on tab4.id_mt_ubi = tab3.id_mt_ubi 
        left join interceros_du_dir_v tab4 on tab4.id_mae_ter = tab1.id_mae_ter                    
        left join usuario tab5 on tab5.username = tab0.usuariolog 
        left join (
        select
        deta.*,
        row_number() over (
        partition by deta.id_debito
        order by deta.id_debito_detalle desc
        ) as rn
        from ca_debito_detalle deta
        )tab5 on tab5.id_debito = tab1.id_debito and tab5.rn=1
        join ca_debito_detalle tab8 on tab8.id_debito = tab1.id_debito 
        join ca_producto tab6 on tab6.id_producto = tab8.id_producto 
        left join( 
        select id_credito,sum(nvl(valor,0)) as valor 
        from ca_excedentes 
        group by id_credito 
        )tab7 on tab7.id_credito = tab0.id_credito
        
        left join (
          select
           tab0.id_debito,
           tab0.id_vencimiento,
            to_char(wm_concat(distinct tab0.id_tipo_novedad)) as id_tipo_novedad,
            to_char(wm_concat(distinct tip.descripcion)) as descripcion,
            to_char(wm_concat(distinct tip.desc_corta)) as desc_corta
           from ca_novedad_cartera tab0
           left join ca_tipo_novedad tip
           on tip.id_tipo_novedad = tab0.id_tipo_novedad
           where
           tab0.anulado = 0
           $whereTipoNovedad
           group by
           tab0.id_debito,
           tab0.id_vencimiento   
        )tab13 
        on tab13.id_debito = tab1.id_debito 
        and tab13.id_vencimiento = tab0.id_vencimiento 
        
        where 
        tab0.fecha_proceso_cre between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD')
        $whereConCredito
        $whereTercero  
    
    )tab0
    
    where
    1 = 1
    $whereTipoNovedad 
    $wherePuntoVenta
    
    group by id_con_credito, desc_corta_concre 
    
    union 
    
    select tab0.* from (
    
        select 2 as orden,
        tab0.nombre_pv as punto,            
        tab0.id_credito, 
        tab0.id_punto_venta, 
        tab0.id_tipo_credito, 
        tab0.sec_credito, 
        tab0.id_con_credito, 
        tab0.fecha_proceso_cre,
        tab0.num_doc, 
        tab0.estado_cre as estado, 
        nvl(tab0.valor_abono,0)+nvl(tab0.diferencia_cambio,0)+nvl(tab7.valor,0) as valor_bruto_credet, 
        tab0.valor_retenciones, 
        nvl(tab0.valor_abono,0)+nvl(tab0.diferencia_cambio,0)+nvl(tab7.valor,0) as valor_abono,
        tab0.fecha_anu_cre, 
        tab0.motivo_anu, 
        tab6.codigo as concepto, 
        tab1.sec_debito, 
        tab1.id_tipo_debito, 
        tab1.fecha_proceso as fecha_debito, 
        tab2.desc_corta as desc_deb,
        tab0.descripcion_tipcre,
        ter.num_doc as nitocc,
        ter.razon_soc as razon_soc,
        ter.id_mae_ter as id_mae_ter,
        ter.num_doc || ' - ' || ter.razon_soc as tercero,
        tab13.id_tipo_novedad,
        tab13.descripcion AS descripcion_tipnov,
        tab13.desc_corta AS desc_corta_tipnov 
        
        
        from ca_credito_vencimientos tab0 
        join ca_debito tab1 on tab1.id_debito = tab0.id_debito 
        join ca_tipo_debito tab2 on tab2.id_tipo_debito = tab1.id_tipo_debito 
        join interceros ter on ter.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du tab3 on tab3.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du_dir tab4 on tab4.id_mt_ubi = tab3.id_mt_ubi 
        left join interceros_du_dir_v tab4 on tab4.id_mae_ter = tab1.id_mae_ter  
        left join usuario tab5 on tab5.username = tab0.usuariolog 
        left join (
        select
        deta.*,
        row_number() over (
        partition by deta.id_debito
        order by deta.id_debito_detalle desc
        ) as rn
        from ca_debito_detalle deta
        )tab5 on tab5.id_debito = tab1.id_debito and tab5.rn=1
        join ca_producto tab6 on tab6.id_producto = tab5.id_producto 
        left join( 
        select id_credito,sum(nvl(valor,0)) as valor 
        from ca_excedentes 
        group by id_credito 
        )tab7 on tab7.id_credito = tab0.id_credito
        
        left join (
          select
           tab0.id_debito,
           tab0.id_vencimiento,
            to_char(wm_concat(distinct tab0.id_tipo_novedad)) as id_tipo_novedad,
            to_char(wm_concat(distinct tip.descripcion)) as descripcion,
            to_char(wm_concat(distinct tip.desc_corta)) as desc_corta
           from ca_novedad_cartera tab0
           left join ca_tipo_novedad tip
           on tip.id_tipo_novedad = tab0.id_tipo_novedad
           where
           tab0.anulado = 0
           $whereTipoNovedad
           group by
           tab0.id_debito,
           tab0.id_vencimiento   
        )tab13 
        on tab13.id_debito = tab1.id_debito 
        and tab13.id_vencimiento = tab0.id_vencimiento  
        
        where 
        tab0.fecha_proceso_cre between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD')
        $whereConCredito
        $whereTercero  
    
    )tab0
    
    where
    1 = 1
    $whereTipoNovedad 
    $wherePuntoVenta
    
    order by id_con_credito

) 
                    
)
EOD;




            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select * from (


    select distinct 1 as orden,
    null as punto,   
    null as id_credito, 
    null as id_punto_venta, 
    null as id_tipo_credito, 
    null as sec_credito, 
    tab0.id_con_credito, 
    null as fecha_proceso_cre,
    null as num_doc, 
    null as estado, 
    null as valor_bruto_credet, 
    null as valor_retenciones, 
    null as valor_abono, 
    null as fecha_anu_cre, 
    null as motivo_anu, 
    null as concepto, 
    null as sec_debito, 
    null as id_tipo_debito, 
    null as fecha_debito, 
    null as desc_deb,
    null as descripcion_tipcre, 
    null as nitocc, 
    null as razon_soc, -1 as id_mae_ter,
    'NOTA CREDITO: ' || tab0.desc_corta_concre as tercero,
    null as id_tipo_novedad,
    null as descripcion_tipnov,
    null as desc_corta_tipnov 
    
    from(
    
        select tab0.*,
        tab13.id_tipo_novedad,
        tab13.descripcion AS descripcion_tipnov,
        tab13.desc_corta AS desc_corta_tipnov  
        
        from ca_credito_vencimientos tab0 
        join ca_debito tab1 on tab1.id_debito = tab0.id_debito 
        join ca_tipo_debito tab2 on tab2.id_tipo_debito = tab1.id_tipo_debito 
        join interceros ter on ter.id_mae_ter = tab1.id_mae_ter
        --left join intercer_du tab3 on tab3.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du_dir tab4 on tab4.id_mt_ubi = tab3.id_mt_ubi 
        left join interceros_du_dir_v tab4 on tab4.id_mae_ter = tab1.id_mae_ter  
        left join usuario tab5 on tab5.username = tab0.usuariolog 
        left join (
        select
        deta.*,
        row_number() over (
        partition by deta.id_debito
        order by deta.id_debito_detalle desc
        ) as rn
        from ca_debito_detalle deta
        )tab5 on tab5.id_debito = tab1.id_debito and tab5.rn=1
        join ca_producto tab6 on tab6.id_producto = tab5.id_producto 
        
        left join( 
        
        select id_credito,sum(nvl(valor,0)) as valor 
        from ca_excedentes 
        group by id_credito 
        )tab7 on tab7.id_credito = tab0.id_credito
        
        left join (
          select
           tab0.id_debito,
           tab0.id_vencimiento,
            to_char(wm_concat(distinct tab0.id_tipo_novedad)) as id_tipo_novedad,
            to_char(wm_concat(distinct tip.descripcion)) as descripcion,
            to_char(wm_concat(distinct tip.desc_corta)) as desc_corta
           from ca_novedad_cartera tab0
           left join ca_tipo_novedad tip
           on tip.id_tipo_novedad = tab0.id_tipo_novedad
           where
           tab0.anulado = 0
           $whereTipoNovedad
           group by
           tab0.id_debito,
           tab0.id_vencimiento   
        )tab13 
        on tab13.id_debito = tab1.id_debito 
        and tab13.id_vencimiento = tab0.id_vencimiento 
        
        where 
        tab0.fecha_proceso_cre between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD')
        $whereConCredito
        $whereTercero            
    
    
    )tab0
    
    where
    1 = 1
    $whereTipoNovedad 
    $wherePuntoVenta
    
    union 
    
    select 
    distinct 3 as orden, 
    null as punto,   
    null as id_credito, 
    null as id_punto_venta, 
    null as id_tipo_credito, 
    null as sec_credito, 
    id_con_credito, 
    null as fecha_proceso_cre, 
    null as num_doc,
    null as estado, 
    null as valor_bruto_credet, 
    null as valor_retenciones, 
    sum(nvl(valor_abono,0))+sum(nvl(diferencia_cambio,0))+sum(nvl(excedente,0)) as valor_abono, 
    null as fecha_anu_cre, 
    null as motivo_anu, 
    null as concepto, 
    null as sec_debito, 
    null as id_tipo_debito, 
    null as fecha_debito, 
    null as desc_deb, 
    null as descripcion_tipcre, 
    null as nitocc, 
    null as razon_soc
    , -1 as id_mae_ter,
    'TOTAL NOTA CREDITO: ' || desc_corta_concre as tercero,
    null as id_tipo_novedad,
    null as descripcion_tipnov,
    null as desc_corta_tipnov 
    
    from( 
    
        select tab0.*,tab7.valor as excedente,
        tab13.id_tipo_novedad,
        tab13.descripcion AS descripcion_tipnov,
        tab13.desc_corta AS desc_corta_tipnov
        
        from ca_credito_vencimientos tab0 
        join ca_debito tab1 on tab1.id_debito = tab0.id_debito 
        join ca_tipo_debito tab2 on tab2.id_tipo_debito = tab1.id_tipo_debito 
        join interceros ter on ter.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du tab3 on tab3.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du_dir tab4 on tab4.id_mt_ubi = tab3.id_mt_ubi 
        left join interceros_du_dir_v tab4 on tab4.id_mae_ter = tab1.id_mae_ter  
        left join usuario tab5 on tab5.username = tab0.usuariolog 
        left join (
        select
        deta.*,
        row_number() over (
        partition by deta.id_debito
        order by deta.id_debito_detalle desc
        ) as rn
        from ca_debito_detalle deta
        )tab5 on tab5.id_debito = tab1.id_debito and tab5.rn=1
        join ca_debito_detalle tab8 on tab8.id_debito = tab1.id_debito 
        join ca_producto tab6 on tab6.id_producto = tab8.id_producto 
        left join( 
        select id_credito,sum(nvl(valor,0)) as valor 
        from ca_excedentes 
        group by id_credito 
        )tab7 on tab7.id_credito = tab0.id_credito
        
        left join (
          select
           tab0.id_debito,
           tab0.id_vencimiento,
            to_char(wm_concat(distinct tab0.id_tipo_novedad)) as id_tipo_novedad,
            to_char(wm_concat(distinct tip.descripcion)) as descripcion,
            to_char(wm_concat(distinct tip.desc_corta)) as desc_corta
           from ca_novedad_cartera tab0
           left join ca_tipo_novedad tip
           on tip.id_tipo_novedad = tab0.id_tipo_novedad
           where
           tab0.anulado = 0
           $whereTipoNovedad
           group by
           tab0.id_debito,
           tab0.id_vencimiento   
        )tab13 
        on tab13.id_debito = tab1.id_debito 
        and tab13.id_vencimiento = tab0.id_vencimiento 
        
        where 
        tab0.fecha_proceso_cre between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD')
        $whereConCredito
        $whereTercero  
    
    )tab0
    
    where
    1 = 1
    $whereTipoNovedad 
    $wherePuntoVenta
    
    group by id_con_credito, desc_corta_concre 
    
    union 
    
    select tab0.* from (
    
        select 2 as orden,
        tab0.nombre_pv as punto,            
        tab0.id_credito, 
        tab0.id_punto_venta, 
        tab0.id_tipo_credito, 
        tab0.sec_credito, 
        tab0.id_con_credito, 
        tab0.fecha_proceso_cre,
        tab0.num_doc, 
        tab0.estado_cre as estado, 
        nvl(tab0.valor_abono,0)+nvl(tab0.diferencia_cambio,0)+nvl(tab7.valor,0) as valor_bruto_credet, 
        tab0.valor_retenciones, 
        nvl(tab0.valor_abono,0)+nvl(tab0.diferencia_cambio,0)+nvl(tab7.valor,0) as valor_abono,
        tab0.fecha_anu_cre, 
        tab0.motivo_anu, 
        tab6.codigo as concepto, 
        tab1.sec_debito, 
        tab1.id_tipo_debito, 
        tab1.fecha_proceso as fecha_debito, 
        tab2.desc_corta as desc_deb,
        tab0.descripcion_tipcre,
        ter.num_doc as nitocc,
        ter.razon_soc as razon_soc,
        ter.id_mae_ter as id_mae_ter,
        ter.num_doc || ' - ' || ter.razon_soc as tercero,
        tab13.id_tipo_novedad,
        tab13.descripcion AS descripcion_tipnov,
        tab13.desc_corta AS desc_corta_tipnov 
        
        
        from ca_credito_vencimientos tab0 
        join ca_debito tab1 on tab1.id_debito = tab0.id_debito 
        join ca_tipo_debito tab2 on tab2.id_tipo_debito = tab1.id_tipo_debito 
        join interceros ter on ter.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du tab3 on tab3.id_mae_ter = tab1.id_mae_ter 
        --left join intercer_du_dir tab4 on tab4.id_mt_ubi = tab3.id_mt_ubi 
        left join interceros_du_dir_v tab4 on tab4.id_mae_ter = tab1.id_mae_ter  
        left join usuario tab5 on tab5.username = tab0.usuariolog 
        left join (
        select
        deta.*,
        row_number() over (
        partition by deta.id_debito
        order by deta.id_debito_detalle desc
        ) as rn
        from ca_debito_detalle deta
        )tab5 on tab5.id_debito = tab1.id_debito and tab5.rn=1
        join ca_producto tab6 on tab6.id_producto = tab5.id_producto 
        left join( 
        select id_credito,sum(nvl(valor,0)) as valor 
        from ca_excedentes 
        group by id_credito 
        )tab7 on tab7.id_credito = tab0.id_credito
        
        left join (
          select
           tab0.id_debito,
           tab0.id_vencimiento,
            to_char(wm_concat(distinct tab0.id_tipo_novedad)) as id_tipo_novedad,
            to_char(wm_concat(distinct tip.descripcion)) as descripcion,
            to_char(wm_concat(distinct tip.desc_corta)) as desc_corta
           from ca_novedad_cartera tab0
           left join ca_tipo_novedad tip
           on tip.id_tipo_novedad = tab0.id_tipo_novedad
           where
           tab0.anulado = 0
           $whereTipoNovedad
           group by
           tab0.id_debito,
           tab0.id_vencimiento   
        )tab13 
        on tab13.id_debito = tab1.id_debito 
        and tab13.id_vencimiento = tab0.id_vencimiento  
        
        where 
        tab0.fecha_proceso_cre between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD')
        $whereConCredito
        $whereTercero  
    
    )tab0
    
    where
    1 = 1
    $whereTipoNovedad 
    $wherePuntoVenta
    
    order by id_con_credito

) 
    
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart 
EOD;


            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $this->startRow + count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar el informe nota debito
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];


            /*
             * Variables opcionales
             */

            if (isset($request['id_con_credito'])) {
                $whereConCredito = " AND tab0.id_con_credito = " . $request['id_con_credito'];
            } else {
                $whereConCredito = ' ';
            }


            if (isset($request['id_mae_ter'])) {
                $whereTercero = " AND tab1.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }

            //tipo novedad - 20160928
            if (isset($request['id_tipo_novedad'])) {
                $whereTipoNovedad = "and tab0.id_tipo_novedad = " . $request['id_tipo_novedad'];
            } else {
                $whereTipoNovedad = ' ';
            }
            
            //Agregado filtro Punto de venta 20170214
            if(!empty($request['id_punto_venta'])){
                $wherePuntoVenta="and tab0.id_punto_venta = " . $request['id_punto_venta'];
            }else{    
                $wherePuntoVenta=' ';
            }


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT count(*) as sec_credito, 'TOTALES NOTAS CREDITO' as razon_soc,
SUM(NVL(valor_abono,0))+SUM(NVL(diferencia_cambio,0))+SUM(NVL(excedente,0)) as valor_bruto_credet, 
SUM(NVL(valor_retenciones,0)) as valor_retenciones, 
SUM(NVL(valor_abono,0))+SUM(NVL(diferencia_cambio,0))+SUM(NVL(excedente,0)) as valor_abono

FROM (

Select

2 as Orden,
Tab0.*,
Tab1.Sec_Debito,
Tab1.Id_Tipo_Debito,
Tab1.fecha_proceso as fecha_debito,
Tab2.Desc_Corta As Desc_Corta_Tipdeb,
Tab2.Descripcion As Descripcion_Tipdeb,
Ter.Num_Doc As Nitocc,
Ter.Razon_Soc,
Ter.Num_Doc || ' - ' || Ter.Razon_Soc AS tercero,
tab4.direccion,
Tab4.Tel,
Tab4.Ciudad,
tab5.nombre||' '||tab5.apellido AS USUARIO_NAME
,Tab6.codigo as concepto
,Tab7.valor as excedente,

tab13.id_tipo_novedad,
tab13.DESCRIPCION as DESCRIPCION_tipnov,
tab13.DESC_CORTA as DESC_CORTA_tipnov


From Ca_Credito_Vencimientos tab0

Join Ca_Debito Tab1
On Tab1.Id_Debito = Tab0.Id_Debito

Join Ca_Tipo_Debito Tab2
on Tab2.Id_Tipo_Debito = Tab1.Id_Tipo_Debito

Join Interceros Ter
on Ter.Id_Mae_Ter = Tab1.Id_Mae_Ter

--left join intercer_du tab3 on tab3.id_mae_ter = tab1.id_mae_ter 
--left join intercer_du_dir tab4 on tab4.id_mt_ubi = tab3.id_mt_ubi 
left join interceros_du_dir_v tab4 on tab4.id_mae_ter = tab1.id_mae_ter  

LEFT JOIN USUARIO tab5 ON tab5.username = Tab0.Usuariolog

left join (
  SELECT
   deta.*,
   ROW_NUMBER() OVER (
    PARTITION BY deta.id_debito
    ORDER BY deta.id_debito_detalle desc
   ) AS rn
   from ca_debito_detalle deta
)Tab5 ON Tab5.id_debito = Tab1.id_debito and Tab5.rn=1

Join Ca_Producto Tab6 ON Tab6.id_producto = Tab5.id_producto
left join( 
select id_credito,sum(nvl(valor,0)) AS VALOR 
FROM ca_excedentes 
group by id_credito 
)Tab7 ON Tab7.id_credito = tab0.id_credito 
                    

left join (
  select
   tab0.id_debito,
   tab0.id_vencimiento,
   to_char(wm_concat(distinct tab0.id_tipo_novedad)) as id_tipo_novedad,
   to_char(wm_concat(distinct tip.descripcion)) as descripcion,
   to_char(wm_concat(distinct tip.desc_corta)) as desc_corta
   from ca_novedad_cartera tab0
   left join ca_tipo_novedad tip
   on tip.id_tipo_novedad = tab0.id_tipo_novedad
   where
   tab0.anulado = 0
   $whereTipoNovedad 
   group by
   tab0.id_debito,
   tab0.id_vencimiento   
)tab13 
on tab13.id_debito = tab1.id_debito 
and tab13.id_vencimiento = tab0.id_vencimiento 
    
Where
tab0.fecha_proceso_cre between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD')
$whereConCredito
$whereTercero

Order By
Tab0.Id_Con_Credito,
Tab0.Sec_Credito,
Tab0.Id_Tipo_Credito

)tab0

where
1 = 1                    
$whereTipoNovedad
$wherePuntoVenta

EOD;


            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
